// EncryptBinDlg.cpp : implementation file
//

#include "stdafx.h"
#include "EncryptBin.h"
#include "EncryptBinDlg.h"
#include "KSFileDialog.h"
#include "fileheader.h"
#include "Cryptor.h"
#include "AggressiveOptimize.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEncryptBinDlg dialog

CEncryptBinDlg::CEncryptBinDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEncryptBinDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEncryptBinDlg)
	m_InFile = _T("");
	m_OutFile = _T("");
	m_Password = _T("");
	//}}AFX_DATA_INIT
	m_UsePassword=false;
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEncryptBinDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEncryptBinDlg)
	DDX_Text(pDX, IDC_INFILE, m_InFile);
	DDV_MaxChars(pDX, m_InFile, 255);
	DDX_Text(pDX, IDC_OUTFILE, m_OutFile);
	DDV_MaxChars(pDX, m_OutFile, 255);
	DDX_Text(pDX, IDC_PASSWORD, m_Password);
	DDV_MaxChars(pDX, m_Password, 80);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEncryptBinDlg, CDialog)
	//{{AFX_MSG_MAP(CEncryptBinDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ENCRYPT, OnEncrypt)
	ON_BN_CLICKED(IDC_OUTFILB, OnOutfileBrowse)
	ON_BN_CLICKED(IDC_INFILB, OnInfileBrowse)
	ON_BN_CLICKED(IDC_USEPASSWORD, OnUsePassword)
	ON_BN_CLICKED(IDC_DECRYPT, OnDecrypt)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEncryptBinDlg message handlers

BOOL CEncryptBinDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	((CEdit *)GetDlgItem(IDC_PASSWORD))->ShowWindow(m_UsePassword?SW_SHOW:SW_HIDE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CEncryptBinDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEncryptBinDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEncryptBinDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CEncryptBinDlg::OnEncrypt() 
{
	UpdateData(TRUE);
	DoEncrypt();
}

void CEncryptBinDlg::OnOutfileBrowse() 
{
	UpdateData(TRUE);
	CKSFileDialog dlg(FALSE,NULL,m_OutFile,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"Rabbit Image files (*.bin)|*.bin|All files (*.*)|*.*|");
	dlg.SetMyParent(this);
	if (dlg.DoModal()==IDOK)
	{
		m_OutFile=dlg.GetPathName();
		UpdateData(FALSE);	// update screen
	}	
}

void CEncryptBinDlg::OnInfileBrowse() 
{
	UpdateData(TRUE);
	CKSFileDialog dlg(TRUE,NULL,m_InFile,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"Rabbit Image files (*.bin)|*.bin|All files (*.*)|*.*|");
	dlg.SetMyParent(this);
	if (dlg.DoModal()==IDOK)
	{
		m_InFile=dlg.GetPathName();
		UpdateData(FALSE);	// update screen
	}	
}

void CEncryptBinDlg::OnUsePassword() 
{
	m_UsePassword=!m_UsePassword;
	((CButton *)GetDlgItem(IDC_USEPASSWORD))->SetCheck(m_UsePassword?1:0);
	((CEdit *)GetDlgItem(IDC_PASSWORD))->ShowWindow(m_UsePassword?SW_SHOW:SW_HIDE);
}

void CEncryptBinDlg::OnDecrypt() 
{
	int i;
	UpdateData(TRUE);
	CFile fin,fout;
	if (!fin.Open(m_InFile,CFile::modeRead))
	{
		CString err;
		err.Format("Could not open input file: %s",m_InFile);
		GetDlgItem(IDC_STATUS)->SetWindowText(err);
		return;
	}
	EHEADER hdr;
	CCryptor crypt;
	fin.Read(&hdr,sizeof(hdr));
	if (strcmp(hdr.ID,ENCRYPTED_ID)!=0)
	{
		fin.Close();
		CString txt;
		txt.Format("Input file: %s is not encrypted",m_InFile);
		GetDlgItem(IDC_STATUS)->SetWindowText(txt);
		return;
	}
	crypt.Set_Key(hdr.Password[0],hdr.Password[1],hdr.Password[2]);
	if (!fout.Open(m_OutFile,CFile::modeWrite|CFile::modeCreate))
	{
		CString err;
		err.Format("Could not open output file: %s",m_OutFile);
		GetDlgItem(IDC_STATUS)->SetWindowText(err);
		return;
	}
	char * s;
	s=(char *)&hdr.Key;
	for (i=0;i<sizeof(hdr.Key);i++)
		crypt.Transform_Char(s++);
	// actual key in hdr is now encrypted.
	// reset key to original
	crypt.Set_Key(hdr.Key[0],hdr.Key[1],hdr.Key[2]);
	// ok, everything set up;
	char buff[512];
	int len=1;
	while (len)
	{
		len=fin.Read(buff,512);
		s=buff;
		if (len)
		{
			for (i=0;i<len;i++)
				crypt.Transform_Char(s++);
			fout.Write(buff,len);
		}
	}
	fin.Close();
	fout.Close();
	CString txt;
	txt.Format("Input file: %s decrypted as file: %s successfully.",m_InFile,m_OutFile);
	GetDlgItem(IDC_STATUS)->SetWindowText(txt);
	
}

int CEncryptBinDlg::DoEncrypt(bool active)
{
	int i;
	EHEADER hdr;
	CCryptor crypt;
	unsigned long tmpkey[3];
	strcpy(hdr.ID,ENCRYPTED_ID);
	if (!m_UsePassword)
	{
		memset(&hdr.Password,0,sizeof(hdr.Password));
		crypt.Set_Key(0,0,0);
	}
	else
	{
		char * s=(char *)LPCSTR(m_Password);
		crypt.Set_Key(0,0,0);	// use default key
		for (i=0;i<m_Password.GetLength();i++)
			crypt.Transform_Char(s++);
		// crypt variables are now the key
		hdr.Password[0]=crypt.m_LFSR_A;
		hdr.Password[1]=crypt.m_LFSR_B;
		hdr.Password[2]=crypt.m_LFSR_C;
	}
	char *s=(char *)&tmpkey;
	// create random key
	for (i=0;i<sizeof(tmpkey);i++)
		*s++=(char)rand();
	// encrypt the key used
	hdr.Key[0]=tmpkey[0];
	hdr.Key[1]=tmpkey[1];
	hdr.Key[2]=tmpkey[2];
	s=(char *)&hdr.Key;
	for (i=0;i<sizeof(tmpkey);i++)
		crypt.Transform_Char(s++);
	// actual key in hdr is now encrypted.
	// reset key to original
	crypt.Set_Key(tmpkey[0],tmpkey[1],tmpkey[2]);
	CFile fin,fout;
	if (!fin.Open(m_InFile,CFile::modeRead))
	{
		CString err;
		err.Format("Could not open input file: %s",m_InFile);
		if (active)
			GetDlgItem(IDC_STATUS)->SetWindowText(err);
		else
			puts(err);
		return 1;
	}
	if (!fout.Open(m_OutFile,CFile::modeWrite|CFile::modeCreate))
	{
		CString err;
		err.Format("Could not open output file: %s",m_OutFile);
		if (active)
			GetDlgItem(IDC_STATUS)->SetWindowText(err);
		else
			puts(err);
		return 1;
	}
	// ok, everything set up;
	char buff[512];
	int len=1;
	// start by writing header
	fout.Write(&hdr,sizeof(hdr));
	while (len)
	{
		len=fin.Read(buff,512);
		s=buff;
		if (len)
		{
			for (i=0;i<len;i++)
				crypt.Transform_Char(s++);
			fout.Write(buff,len);
		}
	}
	fin.Close();
	fout.Close();
	CString txt;
	txt.Format("Input file: %s encrypted as file: %s successfully.",m_InFile,m_OutFile);
	if (active)
		GetDlgItem(IDC_STATUS)->SetWindowText(txt);
	else
		puts(txt);
	return 0;
}
